## piuparts 0.41

=== Makefile ===
prefix = /usr/local
sbindir = $(prefix)/sbin
sharedir = $(prefix)/share
mandir = $(sharedir)/man
man1dir = $(mandir)/man1
libdir = $(prefix)/lib
docdir = $(prefix)/share/doc/piuparts/
site26 = $(libdir)/python2.6/dist-packages
site27 = $(libdir)/python2.7/dist-packages
etcdir = $(prefix)/etc
distribution=${shell dpkg-parsechangelog | sed -n 's/^Distribution: *//p'}
ifeq ($(distribution),UNRELEASED)
version=${shell echo "`dpkg-parsechangelog | sed -n 's/^Version: *//p'`~`date +%Y%m%d%H%M`"}
else
version=${shell dpkg-parsechangelog | sed -n 's/^Version: *//p'}
endif

ignore = -I fdmount -N

all: install-conf install-doc install

install-doc:
	# build and install manual 
	a2x --copy -a toc -a toclevels=3 -f xhtml -r /etc/asciidoc/ README.txt
	install -d $(docdir)/
	for file in README.txt README.html docbook-xsl.css ; do \
	    install -m 0755 $$file $(docdir)/ ; done
	# build and install manpage
	a2x -f manpage piuparts.1.txt
	install -d $(man1dir) 
	install -m 0644 piuparts.1 $(man1dir)
	gzip -9f $(man1dir)/piuparts.1
	a2x --copy -f xhtml piuparts.1.txt
	install -m 0755 piuparts.1.html $(docdir)

install-conf:
	install -d $(etcdir)/piuparts
	install -m 0644 piuparts.conf.sample $(etcdir)/piuparts/piuparts.conf

install:
	install -d $(sbindir) 
	echo $(version)
	sed -e 's/__PIUPARTS_VERSION__/$(version)/g' piuparts.py > piuparts
	install piuparts $(sbindir)/piuparts
	
	install -d $(sharedir)/piuparts
	for file in piuparts-slave piuparts-master piuparts-report piuparts-analyze; do \
	    install -m 0755 $$file.py $(sharedir)/piuparts/$$file ; done
	
	install -d $(site26)/piupartslib
	install -d $(site27)/piupartslib
	install -m 0644 piupartslib/*.py $(site26)/piupartslib
	install -m 0644 piupartslib/*.py $(site27)/piupartslib

check:
	python piuparts.py unittest
	python unittests.py

clean:
	rm -rf piuparts.1 piuparts.1.xml piuparts.1.html piuparts README.xml README.html docbook-xsl.css piuparts.html

=== debian/changelog ===
piuparts (0.41) unstable; urgency=low

  * piupartslib/packagesdb.py: Apply patch by Scott Schaefer to also consider
    alternative depends: the algorithm used to select the "best" alternative 
    is:
     1) Prefer first alternative in state "essential-required"
     2) If no "essential-required" alternatives, prefer first alternative
        in state "successfully-tested"
     3) Otherwise, prefer first alternative in state 
        "waiting-to-be-tested" IF NO REMAINING alternatives are in one of the
        "unknown/fail" states
    For this two new states have been introduced:
     a) "unknown-preferred-alternative": equivalent of "unknown", this defers
        calculation of this package's state, since one or more of its 
        alternative depends are "unknown" (or 
        "unknown-preferred-alternative"), and no alternative is either 
        "essential-required" or "successfully-tested".  The alternatives will
        be re-tested on subsequest pass.
     b) "no-dependency-from-alternatives-exists": if none of the alternatives
        can be found in the archive.
    (Closes: #526045)
  * piuparts-report.py: 
    - correct a typo from the patch for #523950.
    - make_stats_graph: draw the two new states as well.
    - point to source code in git instead of svn.
  * piuparts.py: 
    - use proxy settings either from apt configuration or http_proxy 
      environment variable, the latter overwriting the former (if present) 
      - Thanks to Scott Schaefer for the patch. (Closes: #632046)
    - new option "--no-install-purge-test" to only do upgrade tests
      - Thanks to Andreas Bergmann for the patch (Closes: #588482)
    - run dpkg with --force-unsafe-io by default and introduce new option
      "--dpkg-noforce-unsafe-io" to disable this feature. (Closes: #633033)
      Thanks to Scott once more!
    - new option: "--fail-on-broken-symlinks". Remove option "--warn-symlinks"
      as this is the default now.
  * piuparts-slave: 
    - check if chroot-tgz is older than max-tgz-age (defaulting to 30 days)
      and recreate it, if it is. Keep backup and put in back in place when 
      debootstrapping a new chroot-tgz fails. Retry after min-tgz-retry-delay
      seconds. Thanks to Scott Schaefer for the patch. (Closes: #632924)
    - document new configuration options max-tgz-age and min-tgz-retry-delay
      in README.txt.
    - fix bug in piuparts-slave which prevented running a single section by 
      including section name as command-line argument - thanks again to Scott
      and see 632924 too.
  * debian/control:
    - require python >= 2.6.6-3~, get rid of python-support build-depends.
    - add X-Python-Version: pseudo-header
  * debian/rules: use dh_python2 instead of python-support to build the 
    package
  * Makefile: build for python 2.6 and 2.7 instead of 2.5 and 2.6.
  * Source code is now stored in git.
    http://anonscm.debian.org/gitweb/?p=piuparts/piuparts.git
    git clone git+ssh://git.debian.org/git/piuparts/piuparts.git
    Thanks to Thomas Koch for setting those up and keeping history!
  * The configuration and scripts used on piatti.debian.org have also been
    moved to git, the URLs are the same, just s#piuparts#piatti#. 
  * Add entry about git to NEWS.
  * Update Vcs-*-Headers in control to reflect move to git.

 -- Holger Levsen <holger@debian.org>  Wed, 24 Aug 2011 13:47:07 +0200

=== debian/control ===
Source: piuparts
Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
Uploaders: Holger Levsen <holger@debian.org>
Section: devel
Priority: extra
Standards-Version: 3.9.2
Build-Depends: debhelper (>=7)
Build-Depends-Indep: python (>=2.6.6-3~), asciidoc, xmlto
Homepage: http://piuparts.debian.org
Vcs-Git: git://anonscm.debian.org/piuparts/piuparts.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=piuparts/piuparts.git
X-Python-Version: >= 2.6

Package: piuparts
Architecture: all
Depends: apt, ${python:Depends}, debootstrap, lsof, lsb-release, 
    python-debian, ${misc:Depends}
Suggests: python-rpy, ghostscript
Description: .deb package installation, upgrading, and removal testing tool
 piuparts tests that .deb packages (as used by Debian) handle
 installation, upgrading, and removal correctly. It does this by
 creating a minimal Debian installation in a chroot, and installing,
 upgrading, and removing packages in that environment, and comparing the
 state of the directory tree before and after. piuparts reports any
 files that have been added, removed, or modified during this process.
 . 
 piuparts is meant as a quality assurance tool for people who create .deb
 packages to test them before they upload them to the Debian package archive.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

build-arch:
build-indep:
build:

clean:
	dh_testdir
	dh_testroot
	$(MAKE) clean
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	dh_installman
	$(MAKE) prefix=$(CURDIR)/debian/piuparts/usr etcdir=$(CURDIR)/debian/piuparts/etc all

binary-arch:
binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installchangelogs
	dh_compress
	dh_fixperms
	dh_python2
	dh_installdeb 
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-arch binary-indep
.PHONY: build clean binary-arch binary-indep binary install

## piuparts 0.42

=== Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 etcdir = $(prefix)/etc
 distribution=${shell dpkg-parsechangelog | sed -n 's/^Distribution: *//p'}
 ifeq ($(distribution),UNRELEASED)
-version=${shell echo "`dpkg-parsechangelog | sed -n 's/^Version: *//p'`~`date +%Y%m%d%H%M`"}
+version=${shell echo "`dpkg-parsechangelog | sed -n 's/^Version: *//p'`~`date +%Y%m%d%H%M`~`git describe --tags --dirty`"}
 else
 version=${shell dpkg-parsechangelog | sed -n 's/^Version: *//p'}
 endif
@@ -42,11 +42,11 @@
 	echo $(version)
 	sed -e 's/__PIUPARTS_VERSION__/$(version)/g' piuparts.py > piuparts
 	install piuparts $(sbindir)/piuparts
-	
+
 	install -d $(sharedir)/piuparts
 	for file in piuparts-slave piuparts-master piuparts-report piuparts-analyze; do \
 	    install -m 0755 $$file.py $(sharedir)/piuparts/$$file ; done
-	
+
 	install -d $(site26)/piupartslib
 	install -d $(site27)/piupartslib
 	install -m 0644 piupartslib/*.py $(site26)/piupartslib

=== debian/changelog ===
piuparts (0.42) unstable; urgency=low

  [ Holger Levsen ]
  * piuparts.py:
    - add to self.ignored_files: /etc/blkid.tab (Closes: #638831)
    - add to self.ignored_patterns: /var/lib/apt/lists/.*
    - apply patch by Gregor Herrmann to fix --minimize. (Closes: #648423)
  * Remove Debian.NEWS entry about source in git. (Closes: #640121)
  * piuparts.py, piuparts-report.py, ChangeLog: Expand tabs to spaces.
  * Remove whitespaces from whitespace-only lines.
  * piuparts-report: 
    - create maintainer subdirs if they don't exist.
    - detect tests being terminated due to excessive output.
  * Add git to Build-Depends-Indep: as git describe is used to generate
    part of the version string for development builds.
  * Add debian/.gitignore

  [ Mika Pflüger ]
  * piuparts-analyze.py:
    - Rewrite to use python-debianbts to analyze if bugs are filed already.
    - The BTS only tracks source versions, so remove binNMU-part from
      package versions when comparing with versions from the BTS.
    - Reduce noise in the output by only printing one action/advise per
      package.
    - Fix extraction of package versions from bug reports. Thanks to
      Andreas Beckmann for catching and solving the error.
  * debian/control: Add python-apt and python-debianbts to piuparts depends.

  [ Scott Schaefer ]
  * debian/copyright: Make it compliant with DEP-5.
  * piuparts-slave.py: 
    - Replace deprecated os.popen2 with subprocess.Popen. (Closes: #640646)
    - Add some more logging.
    - Kill children (hard-coded value, 45 minutes) to ensure test doesn't
      run "forever" (Closes: #640647, #387428)
  * piuparty.py:
    - Kill leftover processes (via SIGTERM, then if that fails, via SIGKILL).
      (Closes: #522918)
    - Test for incorrect diversion handling:  (Closes: #588313)
      a) Existing diversions removed/modified, and/or
      b) Installed diversions not removed by purge.
  * piupartslib/packagesdb.py: Modify several functions in PackagesDB class
    to use python 'set' type, instead of a list.  This permitted replacing 
    inefficient combination of unique() function and random.shuffle() with
    python set.pop() method.  Since python prohibits storing non-hashable
    object in a set, minor modifications to piuparts-report and to
    piuparts-master required. (Closes: #640648)

  [ Andreas Beckmann ]
  * *.py: Add vim modeline.
  * piuparts.py:
    - Add unittests for misbehaving symlinks.
    - Fix resolving absolute symlinks of intermediate directory components,
      i.e. /var/run -> /run while checking /etc/motd -> /var/run/motd.
      Solves about 30000 false positives of
      'Broken symlinks: /etc/motd -> /var/run/motd'.  (Closes: #648784)
    - When running commands in the chroot, redirect stdin from /dev/null.
    - Stop using Popen.communicate() as it may run out of memory.
    - Terminate commands producing more than 2 MB of output. (Closes: #649335)
    - Create /etc/dpkg/dpkg.cfg.d/ if missing inside the chroot (e.g. on
      lenny).  (Closes: #647752)
    - Remove logrotate and its dependencies only once.
    - Only run 'apt-get update' after updating the sources.list.
    - Only run 'apt-get clean' before creating tarballs or saving meta data.
    - Do the same checks for running processes and broken symlinks in all
      tests.  (Closes: #648708)
    - Create piupart's apt config in the chroot as /etc/apt.conf.d/piuparts
      instead of /etc/apt.conf in order to allow overriding the settings from
      custom scripts by just dropping new config bits in e.g.
      /etc/apt/apt.conf.d/piuparts-foobar.
    - Integrate diversion checks with Chroot.check_result().
    - Use 'apt-get remove' to remove all packages at once with proper
      dependency ordering.  (Closes: #648162)
    - Purge all packages at once instead of doing it one-by-one.
    - Make restore_selections() reinstall missing packages.  (Closes: #648707)
    - Set more environment variables to let custom scripts know where and
      when they are being run: PIUPARTS_TEST, PIUPARTS_PHASE,
      PIUPARTS_DISTRIBUTION{,_PREV,_NEXT}.  See the README for details.
      (Closes: #589498)
    - Add missing post_install_* custom scripts to install_packages_by_name().
      (Closes: #628077)
    - Remove pre_upgrade_* custom scripts, they can be replaced with
      pre_install_* scripts that check for PIUPARTS_PHASE=upgrade.
    - Add pre_test_* custom scripts.  These are run exactly once at the
      beginning of each test (after recording the initial chroot state).
    - Allow multiple --scriptsdir options, the contents will be merged.
    - Exclude /tmp/scripts when creating a tarball.
    - Use --one-file-system when creating a tarball to exclude bindmounts etc.
    - Restore base system from temp_tgz instead of running debootstrap again.
      (Closes: #648193)
    - Do not fail upgrade/distupgrade tests for a set of packages where not
      all packages exist in the start distribution.  This happens e.g. when
      testing .changes files and packages were split/added. Only install the
      old packages that actually exist according to 'apt-cache show'.
    - Add --extra-old-packages option to intall additional old packages that
      are not in the set of new packages to be tested.  Useful for testing
      upgrades with Conflicts/Replaces relationships, e.g. in package renames
      or merges.
    - Use consistent variable names for package lists.  (Closes: #648177)
    - Compute the changes in restore_selections().
    - Check for settings.scriptsdir inside run_scripts().
    - Consistently use chroot.relative() to build filenames inside the chroot.
  * piupartslib/packagesdb.py:
    - Handle 'unknown-preferred-alternative' state correctly.
    - Add 'does-not-exist' state for dependency resolution to distinguish this
      from 'unknown' state so that the latter only indicates 'unresolvable' or
      'not yet resolved'.
    - Handle virtual packages separately from real packages.


## piuparts 0.43

=== debian/changelog ===
piuparts (0.43) unstable; urgency=low

  [ Andreas Beckmann ]
  * piuparts.py:
    - Add to self.ignored_patterns: /run/.*
    - Unset DISPLAY variable before running commands in the chroot.
    - Read possibly remaining buffered output after a command terminated.
    - Run apt-cache policy on the packages to be installed.
    - Simplify keeping the reference chroot state: move tree info, selections
      and diversions into a dict, can be extended easily.
    - Fix --*end-meta documentation and actually enable these options.
    - Cleanup options and settings.
  * piupartslib/packagesdb.py:
    - Restrict circular-dependency state to packages on the circle.
  * piuparts-master.py:
  * piuparts-slave.py:
    - Fix chdir in/out of the slave dir to work with relative paths.
  * piuparts-report.py:
    - Reorder the list of known problem analyses and add a few new ones.
    - Correctly split + strip comma-separated lists.
  * piuparts-analyze.py:
    - Also consider bugs that 'affects' a package.
    - Treat bugs without 'found' version as older than anything.
  * Makefile: Support version number substitution in piuparts-*.py, too.
  * README.txt: Document piuparts.conf settings used by piatti.git scripts.

  [ Holger Levsen ]
  * piuparts.1.txt: correctly reverse the description of --save-end-meta
    and --end-meta.
  * piuparts-report.py:
    - add support for more static pages and add bug_howto.tpl, explaining how
      to file meaningful bugs piuparts-analyse understands. This page also
      links to the templates used for bug filing.
  * piuparts-slave.py: make status message more useful by including the
    section.

 -- Holger Levsen <holger@debian.org>  Sun, 22 Jan 2012 13:03:59 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Priority: extra
 Standards-Version: 3.9.2
 Build-Depends: debhelper (>=7)
-Build-Depends-Indep: python (>=2.6.6-3~), asciidoc, xmlto
+Build-Depends-Indep: python (>=2.6.6-3~), asciidoc, xmlto, git
 Homepage: http://piuparts.debian.org
 Vcs-Git: git://anonscm.debian.org/piuparts/piuparts.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=piuparts/piuparts.git
@@ -14,7 +14,7 @@
 Package: piuparts
 Architecture: all
 Depends: apt, ${python:Depends}, debootstrap, lsof, lsb-release, 
-    python-debian, ${misc:Depends}
+    python-debian, ${misc:Depends}, python-debianbts, python-apt
 Suggests: python-rpy, ghostscript
 Description: .deb package installation, upgrading, and removal testing tool
  piuparts tests that .deb packages (as used by Debian) handle

## piuparts 0.43ubuntu1

=== Makefile ===
--- 
+++ 
@@ -39,13 +39,15 @@
 
 install:
 	install -d $(sbindir) 
-	echo $(version)
 	sed -e 's/__PIUPARTS_VERSION__/$(version)/g' piuparts.py > piuparts
 	install piuparts $(sbindir)/piuparts
+	rm piuparts
 
 	install -d $(sharedir)/piuparts
 	for file in piuparts-slave piuparts-master piuparts-report piuparts-analyze; do \
-	    install -m 0755 $$file.py $(sharedir)/piuparts/$$file ; done
+	    sed -e 's/__PIUPARTS_VERSION__/$(version)/g' $$file.py > $$file ; \
+	    install -m 0755 $$file $(sharedir)/piuparts/$$file ; \
+	    rm $$file ; done
 
 	install -d $(site26)/piupartslib
 	install -d $(site27)/piupartslib

=== debian/changelog ===
piuparts (0.43ubuntu1) precise; urgency=low

  * Merge from Debian testing (LP: #926738).  Remaining changes:
    - In Ubuntu, debfoster tries to remove packages with priority required
      even if MaxPriority=required is used. Setting MaxPriority to important
      reduces the number of packages to be removed as well as false positives
      generated by unwanted package removals. This can be dropped if a
      proper fix for debfoster is found.
    - piuparts.py:
      + Set default keyring name to ubuntu-archive-keyring.pgp
      + Set default distribution to precise.
  * New patch add-existing-chroot-option.patch (LP: #926730):
    - add --existing-chroot option to piuparts, it is useful when you use
      pbuilder with "--no-targz" option, that creates a chroot within 
      a directory instead of a ".tar.gz" file.

 -- Leo Iannacone <l3on@ubuntu.com>  Thu, 16 Feb 2012 00:59:06 +0200

piuparts (0.42ubuntu1) precise; urgency=low

  * Merge from Debian testing.  Remaining changes:
    - In Ubuntu, debfoster tries to remove packages with priority required
      even if MaxPriority=required is used. Setting MaxPriority to important
      reduces the number of packages to be removed as well as false positives
      generated by unwanted package removals. This can be dropped if a
      proper fix for debfoster is found.
    - piuparts.py:
      + Set default keyring name to ubuntu-archive-keyring.pgp
      + Set default distribution to precise.

 -- Mahyuddin Susanto <udienz@ubuntu.com>  Wed, 04 Jan 2012 17:10:09 +0700

piuparts (0.41ubuntu2) precise; urgency=low

  * Rebuild to drop python2.6 dependencies.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 31 Dec 2011 02:06:46 +0000

piuparts (0.41ubuntu1) precise; urgency=low

  * Merge from Debian Unstable. Remaining changes:
    - In Ubuntu, debfoster tries to remove packages with priority required
      even if MaxPriority=required is used. Setting MaxPriority to important
      reduces the number of packages to be removed as well as false positives
      generated by unwanted package removals. This can be dropped if a
      proper fix for debfoster is found.
    - piuparts.py: Set default keyring name to ubuntu-archive-keyring.pgp
  *  piuparts.py: Set default distribution to precise.

 -- Andrew Starr-Bochicchio <a.starr.b@gmail.com>  Mon, 24 Oct 2011 13:54:01 -0400

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: piuparts
-Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
 Uploaders: Holger Levsen <holger@debian.org>
 Section: devel
 Priority: extra

## piuparts 0.44~bpo60+1

=== Makefile ===
--- 
+++ 
@@ -24,14 +24,14 @@
 	a2x --copy -a toc -a toclevels=3 -f xhtml -r /etc/asciidoc/ README.txt
 	install -d $(docdir)/
 	for file in README.txt README.html docbook-xsl.css ; do \
-	    install -m 0755 $$file $(docdir)/ ; done
+	    install -m 0644 $$file $(docdir)/ ; done
 	# build and install manpage
 	a2x -f manpage piuparts.1.txt
 	install -d $(man1dir) 
 	install -m 0644 piuparts.1 $(man1dir)
 	gzip -9f $(man1dir)/piuparts.1
 	a2x --copy -f xhtml piuparts.1.txt
-	install -m 0755 piuparts.1.html $(docdir)
+	install -m 0644 piuparts.1.html $(docdir)
 
 install-conf:
 	install -d $(etcdir)/piuparts

=== debian/changelog ===
piuparts (0.44~bpo60+1) squeeze-backports; urgency=low

  * Rebuild for squeeze-backports.

 -- Holger Levsen <holger@debian.org>  Sat, 23 Jun 2012 10:44:31 +0000

piuparts (0.44) unstable; urgency=low

  [ Andreas Beckmann ]
  * piuparts.py:
    - Add to self.ignored_patterns: /var/lib/ucf/.*
    - Increase output limit to 3 MB (for dist-upgrading daptup).
    - Do not miss Pre-Depends in --warn-on-others mode.
    - Remove packages and reinstall missing ones in one apt-get call.
    - Run 'apt-get dist-upgrade' (instead of upgrade) during chroot setup.
  * piupartslib/packagesdb.py:
    - Only consider the newest version of a package as test candidate.
      (Packages files may contain more than version of the same package.)
  * piuparts-master.py:
    - Implement simple section locking to allow concurrent master instances
      but allow only one instance per section.
  * piuparts-slave.py:
    - Do not leak the logfile file descriptor to piuparts.
    - Skip disabled sections (max-reserved = 0).
    - Do not abort if connection to master failed, just skip the section.
    - Do not abort if Packages file cannot be fetched, just skip the section.
    - Implement simple section locking to allow concurrent slave instances.
    - Sections wait before retry 15 minutes after error and one hour if idle.
    - Create idle.stamp files to remember idle sections for one hour and
      notify concurrent slaves about idle state.
    - Skip misconfigured sections that have neither 'distro' nor
      'upgrade-test-distros' in their config.  (Closes: #668863)
  * piuparts-report.py:
    - Add link to the list of untestable logs.
    - Add more known problem reports: forgotten alternatives, warnings in
      passed logs: leftover files and failed maintainer scripts.
    - Do not abort if logfiles disappear during copying.
  * Makefile: Install documentation with mode 0644 instead of 0755.

  [ Holger Levsen ]
  * piuparts-report: don't create output for disabled sections. (Bye bye
    Lenny!)
  * Bump Standards-Version to 3.9.3, no changes necessary.

 -- Holger Levsen <holger@debian.org>  Thu, 17 May 2012 14:36:53 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: piuparts
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
+Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
 Uploaders: Holger Levsen <holger@debian.org>
 Section: devel
 Priority: extra
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Build-Depends: debhelper (>=7)
 Build-Depends-Indep: python (>=2.6.6-3~), asciidoc, xmlto, git
 Homepage: http://piuparts.debian.org

## piuparts 0.45

=== Makefile ===
--- 
+++ 
@@ -5,6 +5,7 @@
 man1dir = $(mandir)/man1
 libdir = $(prefix)/lib
 docdir = $(prefix)/share/doc/piuparts/
+svrdocdir = $(prefix)/share/doc/piuparts-master
 site26 = $(libdir)/python2.6/dist-packages
 site27 = $(libdir)/python2.7/dist-packages
 etcdir = $(prefix)/etc
@@ -20,25 +21,47 @@
 all: install-conf install-doc install
 
 install-doc:
-	# build and install manual 
+	# build and install manual
 	a2x --copy -a toc -a toclevels=3 -f xhtml -r /etc/asciidoc/ README.txt
 	install -d $(docdir)/
 	for file in README.txt README.html docbook-xsl.css ; do \
 	    install -m 0644 $$file $(docdir)/ ; done
 	# build and install manpage
 	a2x -f manpage piuparts.1.txt
-	install -d $(man1dir) 
+	install -d $(man1dir)
 	install -m 0644 piuparts.1 $(man1dir)
 	gzip -9f $(man1dir)/piuparts.1
 	a2x --copy -f xhtml piuparts.1.txt
 	install -m 0644 piuparts.1.html $(docdir)
+	install -d $(svrdocdir)/
+	install -m 0755 README_server.txt $(svrdocdir)/
 
 install-conf:
 	install -d $(etcdir)/piuparts
-	install -m 0644 piuparts.conf.sample $(etcdir)/piuparts/piuparts.conf
+	install -m 0644 conf/piuparts.conf.sample $(etcdir)/piuparts/piuparts.conf
+
+	install -d $(etcdir)/cron.d
+	install -m 0644 home/piupartsm/crontab $(etcdir)/cron.d/piuparts-master
+	install -m 0644 home/piupartss/crontab $(etcdir)/cron.d/piuparts-slave
+	sed -i -r '/^[^#]+/s/^/#/' $(etcdir)/cron.d/piuparts-*
+
+	install -d $(etcdir)/piuparts/known_problems
+	for fl in home/piupartsm/bin/known_problems/* ; do\
+            install -m 0644 $$fl $(etcdir)/piuparts/known_problems; \
+        done
+
+	install -d $(etcdir)/sudoers.d
+	install -m 440 conf/piuparts.sudoers $(etcdir)/sudoers.d/piuparts
+	sed -i -r '/^[^#]+/s/^/#/' $(etcdir)/sudoers.d/piuparts
+
+	install -d $(etcdir)/apache2/conf.d
+	install -m 0644 conf/piuparts.apache $(etcdir)/apache2/conf.d
+
+	install -d $(etcdir)/piuparts/scripts
+	install org/piuparts.debian.org/etc/scripts/* $(etcdir)/piuparts/scripts
 
 install:
-	install -d $(sbindir) 
+	install -d $(sbindir)
 	sed -e 's/__PIUPARTS_VERSION__/$(version)/g' piuparts.py > piuparts
 	install piuparts $(sbindir)/piuparts
 	rm piuparts
@@ -54,9 +77,37 @@
 	install -m 0644 piupartslib/*.py $(site26)/piupartslib
 	install -m 0644 piupartslib/*.py $(site27)/piupartslib
 
+	install -d $(sharedir)/piuparts/master
+
+	for fl in home/piupartsm/bin/* ; do\
+            if [ -f $$fl ] ; then install $$fl $(sharedir)/piuparts/master ; fi ; done
+
+	install -d $(sharedir)/piuparts/slave
+
+	cp -r home/piupartss/bin/* $(sharedir)/piuparts/slave
+
+	install -d $(sharedir)/piuparts/htdocs
+	for file in org/piuparts.debian.org/htdocs/* ; do\
+            if [ -f $$file ] ; then \
+                install -m 0644 $$file $(sharedir)/piuparts/htdocs ;\
+            fi \
+        done
+
+	install -d $(sharedir)/piuparts/htdocs/images
+	install -m 0644 org/piuparts.debian.org/htdocs/images/* $(sharedir)/piuparts/htdocs/images
+
+	install -d $(sharedir)/piuparts/htdocs/templates/mail
+	for file in org/piuparts.debian.org/htdocs/templates/mail/* ; do\
+		if [ -f $$file ] ; then \
+			install -m 0644 $$file $(sharedir)/piuparts/htdocs/templates/mail ;\
+		fi \
+	done
+
+
 check:
 	python piuparts.py unittest
 	python unittests.py
 
 clean:
-	rm -rf piuparts.1 piuparts.1.xml piuparts.1.html piuparts README.xml README.html docbook-xsl.css piuparts.html 
+	rm -f piuparts.1 piuparts.1.xml piuparts.1.html piuparts README.xml README.html docbook-xsl.css piuparts.html
+	rm -f *.pyc piupartslib/*.pyc

=== debian/changelog ===
piuparts (0.45) unstable; urgency=low

  [ Holger Levsen ]
  * Merge piatti.git into piuparts.git, so that piatti.git has become obsolete
    now. Update documentation accordingly.
  * Further split packaging into piuparts-master, piuparts-slave and
    piuparts-common binary packages (Closes: #585861) and cleanup
    dependencies.
  * Update piuparts.NEWS about master+slave packages.
  * Switch to debhelper8 packaging.
  * debian/copyright: use versioned URI of the machine-readable copyright file,
    thanks lintian.
  * Move /etc/sudoers.d/piuparts to piuparts-slave package.
  * piuparts-master: depend on tango-icon-theme and drop sunny.png and
    weather-severe-alert.png and use links instead.
  * Reviewed and merged/cherry-picked all of the following changes.

  [ David Steele ]
  * Remove debian/postinst as it was only dealing with lenny time area
    configuration files.
  * Added server configuration files for apache, sudo, and cron.
  * Use dh_install, in preparation for multiple package build.
  * Added packaging to create the piuparts-server package out of the old
    piatti directory tree (Closes: #652934).
    - Create and configure piupartss and piupartsm users.
    - Coordinate ssh keys between master and slave users.
    - Create working directory tree for each under /var/lib/piuparts
  * packagesdb.py:
    - Calculate recursive reverse dependency count, and store in PackagesDB.
    - Calculate the count of packages being blocked by a failed package.
  * piuparts-report.py:
    - Release Section object when section processing is complete.
      (Closes: #673919)
    - Display reverse dependency counts and block counts to failure summaries.
    - Sort the failed-testing and cannot-be-tested summaries by block count.
      (Closes: #674498)
    - Replace O(n^2) search in remove_old_logs() with a hash
      piuparts-report run time improved 20% on mature environment.
    - Another search fix in create_package_summaries (find_links_to_logs)
      yielding a 10x speedup for piuparts-report runs.
      (Closes: #674672)
    - Cleanup/wrap some long source lines.
    - Cleanup/wrap some long html lines.
    - Allow the html root to be changed from /
      (piuparts.conf: e.g. [global] doc-root = /piuparts/).

  [ Andreas Beckmann ]
  * piuparts.py:
    - Implement --install-remove-install option to test installation in
      config-files-remaining state.  (Closes: #359154)
    - Report leftover symlinks with target.
    - Report leftover directories with a trailing slash.
    - Allow ignore entries to specifically match directories.
    - Ignore patterns need to match the full filename, not a substring.
    - Cleanup and regroup ignore lists.
      + Remove many obsolete entries not needed for squeeze or later.
      + Group ignore entries into piuparts state, system state, package
        management, logfiles, home directories, application data, and HACKS.
    - Add to ignored_files/ignored_patterns:
      + Default system logfiles as created by syslogd in /var/log/
      + Common empty directories in /etc not removed due to dpkg bug #316521
      + cdebconf status files
      + /boot/grub/
      + /etc/X11/default-display-manager
      + /etc/aliases.db
      + /etc/apt/trusted.gpg.d/.*.gpg~
      + /etc/network/interfaces
      + /etc/news/whoami
      + /usr/share/keyrings/debian-archive-removed-keys.gpg~
      + /var/crash/
      + /var/lib/citadel/(data/.*)?
      + /var/lib/gozerbot/
      + /var/lib/nagios/                        (Closes: #668756)
      + /var/lib/openvswitch/(pki/.*)?
      + /var/spool/powerdns/                    (Closes: #531134, #531135)
    - Implement a timeout for commands being run in the chroot.
    - Set time limit to 30 minutes per command. (Closes: #654423)
    - Terminate all processes running inside the chroot before removing the
      chroot; also in case piuparts aborts due to an error.
    - Continue killing running processes as long as new processes get spawned
      in the chroot.
    - Perform chroot cleanup after receiving Ctrl-C/SIGINT, too.
    - Let Chroot register/de-register the cleanup panic handler.
    - Remove temp_tgz on error exit.
    - Remove metapackage build directory on error exit.  (Closes: #663702)
    - Don't remove eatmydata when minimizing a chroot.  (Closes: #658962)
    - Add support for version-qualified package arguments (--apt foo=1.2-3).
    - Switch fallback mirror to http://cdn.debian.net/debian.
  * piuparts.conf:
    - Defaults for all [section] settings can be set in the [global] section.
    - Change master-command to not include the section name so that it can be
      set in the [global] section.
      The section name will be given as an argument to this command.
    - Make doc-root default to "/".
    - New per section key: area (set to one of main, contrib, non-free).
    - New defaults: mirror=http://cdn.debian.net/debian, area=main.
    - Compute URLs from mirror, distro, area, arch.
    - Removed deprecated keys: known_circular_depends, packages-url,
      sources-url.
  * master/db/report: Add a new category /affected/ for failed logs where the
    bug is in a dependency, but only exposed by the package being tested.
    - In the BTS these are reported as          (Closes: #657740)
        Package: buggy-package
        Version: buggy-version
        Affects: package-under-test
        Found: package-under-test/tested-version
    - Reschedule /affected/ logs like /fail/ logs.
  * piupartslib/conf.py:
    - Add support for getting default values from a special section.
    - Add methods to get mirror, distro, area, arch from config file or
      defaults.
    - Add methods to compute URLs to Packages and Sources files.
  * piupartslib/packagesdb.py:
    - Do not consider a package as "untestable" if untestable/ contains a
      logfile from an obsolete version of that package.
    - Simplify handling of package and dependency states.


=== debian/control ===
Source: piuparts
Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
Uploaders:
 Holger Levsen <holger@debian.org>
Section: devel
Priority: extra
Standards-Version: 3.9.3
Build-Depends:
 debhelper (>= 8.1.0~),
 python (>=2.6.6-3~),
Build-Depends-Indep:
 asciidoc,
 git,
 xmlto
Homepage: http://piuparts.debian.org
Vcs-Git: git://anonscm.debian.org/piuparts/piuparts.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=piuparts/piuparts.git
X-Python-Version: >= 2.6

Package: piuparts
Architecture: all
Pre-Depends:
 dpkg (>= 1.15.7.2~),
Depends:
 debootstrap,
 lsb-release,
 lsof,
 python-debian,
 ${misc:Depends},
 ${python:Depends}
Suggests:
 schroot
Description: .deb package installation, upgrading, and removal testing tool
 piuparts tests that .deb packages (as used by Debian) handle
 installation, upgrading, and removal correctly. It does this by
 creating a minimal Debian installation in a chroot, and installing,
 upgrading, and removing packages in that environment, and comparing the
 state of the directory tree before and after. piuparts reports any
 files that have been added, removed, or modified during this process.
 .
 piuparts is meant as a quality assurance tool for people who create .deb
 packages to test them before they upload them to the Debian package archive.

Package: piuparts-master
Architecture: all
Depends:
 piuparts-common (= ${binary:Version}),
 adduser,
 openssh-server,
 python-debianbts,
 ${misc:Depends},
 ${python:Depends}
Recommends:
 apache2,
 ghostscript,
 python-rpy,
 r-base-dev,
 r-recommended,
 tango-icon-theme
Breaks:
 piuparts (<= 0.44)
Replaces:
 piuparts (<= 0.44)
Description: piuparts master components
 piuparts is meant as a quality assurance tool for people who create .deb
 packages to test them before they upload them to the Debian package archive.
 A master/slave piuparts installation is used for testing complete archives
 as it is done on http://piuparts.debian.org/.
 .
 This package provides the piuparts-master, which needs one or more slave to
 operate. It also contains piuparts-reports to generate web pages with the
 testing results as well as documentation.

Package: piuparts-slave
Architecture: all
Depends:
 piuparts (= ${binary:Version}),
 piuparts-common (= ${binary:Version}),
 adduser,
 openssh-client,
 screen,
 ${misc:Depends},
 ${python:Depends}
Suggests:
 schroot
Breaks:
 piuparts (<= 0.44)
Replaces:
 piuparts (<= 0.44)
Description: piuparts slave components
 piuparts is meant as a quality assurance tool for people who create .deb
 packages to test them before they upload them to the Debian package archive.
 A master/slave piuparts installation is used for testing complete archives
 as it is done on http://piuparts.debian.org/.
 .
 This package provides the piuparts slave components, which need a piuparts
 master to operate. See the documentation in the piuparts-master package.

Package: piuparts-common
Architecture: all
Depends:
 python-apt,
 ${misc:Depends},
 ${python:Depends}
Breaks:
 piuparts (<= 0.44)
Replaces:
 piuparts (<= 0.44)
Description: common piuparts components
 piupartslib, common library used by piuparts-master, -reports, -analyze and
 -slave.
 .
 See http://piuparts.debian.org or the piuparts package to learn more about
 piuparts.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with python2


override_dh_auto_build:
	# do nothing

override_dh_auto_test:
	echo "unittests are disabled as they haven't been run at build time since years and thus are broken..."

override_dh_auto_install:
	$(MAKE) prefix=$(CURDIR)/debian/tmp/usr etcdir=$(CURDIR)/debian/tmp/etc all

override_dh_python2:
	dh_python2 -p piuparts-master -p piuparts-slave /usr/share/piuparts
	dh_python2 -N piuparts-master -N piuparts-slave

## piuparts 0.45ubuntu1

=== debian/changelog ===
piuparts (0.45ubuntu1) quantal; urgency=low

  * Merge from Debian unstable. Remaining Ubuntu changes:
   - In Ubuntu, debfoster tries to remove packages with priority
     required even if MaxPriority=required is used. Setting MaxPriority
     to important reduces the number of packages to be removed as well
     as false positives generated by unwanted package removals. This can
     be dropped if a proper fix for debfoster is found.
   - piuparts.py: Set default keyring name to ubuntu-archive-keyring.pgp
  * Set default distribution to quantal.
  * Drop add-existing-chroot-option.patch, applied in Debian.

 -- Andrew Starr-Bochicchio <a.starr.b@gmail.com>  Wed, 18 Jul 2012 15:27:22 -0400

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: piuparts
-Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
 Uploaders:
  Holger Levsen <holger@debian.org>
 Section: devel
